=== modified file 'plugin/myisam/mi_open.cc'
--- plugin/myisam/mi_open.cc	2009-06-26 19:37:44 +0000
+++ plugin/myisam/mi_open.cc	2009-07-02 06:42:18 +0000
@@ -491,8 +491,16 @@
   {
     share->temporary=share->delay_key_write=1;
     share->write_flag=MYF(MY_NABP);
-    share->w_locks++;			/* We don't have to update status */
-    share->tot_locks++;
+    /*
+     * The following two statements are commented out as a fix of
+     * bug https://bugs.launchpad.net/drizzle/+bug/387627
+     *
+     * UPDATE can be TRUNCATE on TEMPORARY TABLE (MyISAM).
+     * The root cause of why this makes a difference hasn't
+     * been found, but this fixes things for now.
+     */
+//    share->w_locks++;			// We don't have to update status
+//    share->tot_locks++;
     info.lock_type=F_WRLCK;
   }
   if (((open_flags & HA_OPEN_DELAY_KEY_WRITE) ||

=== added file 'tests/r/update_is_truncate_on_temp_bug_lp387627.result'
--- tests/r/update_is_truncate_on_temp_bug_lp387627.result	1970-01-01 00:00:00 +0000
+++ tests/r/update_is_truncate_on_temp_bug_lp387627.result	2009-07-02 06:42:18 +0000
@@ -0,0 +1,19 @@
+create temporary table t1 (col1 int not null, col2 char(4) not null, primary key(col1)) engine=memory;
+alter table t1 engine=myisam;
+insert into t1 values (1,1),(5,2),(2,3),(3,4),(4,4);
+select * from t1;
+col1	col2
+1	1
+5	2
+2	3
+3	4
+4	4
+update t1 set col2='7' where col1='4';
+select * from t1;
+col1	col2
+1	1
+5	2
+2	3
+3	4
+4	7
+DROP TABLE t1;

=== added file 'tests/t/update_is_truncate_on_temp_bug_lp387627.test'
--- tests/t/update_is_truncate_on_temp_bug_lp387627.test	1970-01-01 00:00:00 +0000
+++ tests/t/update_is_truncate_on_temp_bug_lp387627.test	2009-07-02 06:42:18 +0000
@@ -0,0 +1,8 @@
+create temporary table t1 (col1 int not null, col2 char(4) not null, primary key(col1)) engine=memory;
+#create table t1 (col1 int not null, col2 char(4) not null, primary key(col1)) engine=memory;
+alter table t1 engine=myisam;
+insert into t1 values (1,1),(5,2),(2,3),(3,4),(4,4);
+select * from t1;
+update t1 set col2='7' where col1='4';
+select * from t1;
+DROP TABLE t1;

